/// <reference types="node" />
import { Connection } from '@solana/web3.js';
import { AmmanAccount } from '../types';
import { AccountProvider } from './providers';
import EventEmitter from 'events';
import { AccountDiff } from '../relay/types';
export declare type AccountState = {
    account: AmmanAccount;
    slot: number;
    accountDiff?: AccountDiff;
    rendered?: string;
};
declare class AccountStateTracker {
    readonly states: (AccountState & {
        timestamp: number;
    })[];
    add(state: AccountState): void;
    get relayStates(): {
        slot: number;
        accountDiff?: AccountDiff | undefined;
        rendered?: string | undefined;
        timestamp: number;
        account: Record<string, any>;
    }[];
}
export declare class AccountStates extends EventEmitter {
    readonly connection: Connection;
    readonly accountProvider: AccountProvider;
    readonly states: Map<string, AccountStateTracker>;
    private constructor();
    update(address: string, slot: number): Promise<void>;
    add(address: string, state: AccountState): void;
    get(address: string): AccountStateTracker | undefined;
    private _onLog;
    private static _instance;
    static get instance(): AccountStates;
    static createInstance(connection: Connection, accountProvider: AccountProvider): AccountStates | undefined;
}
export declare function printableAccount(account: Record<string, any>): Record<string, any>;
export {};
